/*
	Copyright (C) 2011 Quentin Mathe

	Author:  Quentin Mathe <quentin.mathe@gmail.com>
	Date:  November 2011
	License:  Modified BSD  (see COPYING)
 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import <EtoileFoundation/EtoileFoundation.h>
#ifndef GNUSTEP
#import <EtoileFoundation/GNUstep.h>
#endif
#import <CoreObject/CoreObject.h>
#import <EtoileUI/EtoileUI.h>
#import <EtoileUI/CoreObjectUI.h>

/** An abstract controller class that provides access to the editing context. */
@interface OMController : ETController

/** @taskunit Persistency Integration */

- (COPersistentRoot *)persistentRootFromSelection;
- (COEditingContext *) editingContext;
- (COUndoTrack *) undoTrack;
- (void) handleCommitError: (NSError *)error;

/** @taskunit Selection Interaction */

- (NSArray *) selectedObjects;

@end
